SystemOrganization addCategory: #Unification!
SystemOrganization addCategory: #'Unification-Test'!

!Object methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:46'!
unify: anObject

	^anObject unifyWithNonQuery: self
	! !

!Object methodsFor: '*Unification' stamp: 'hjo 8/8/2012 21:27'!
unifyWithNonQuery: anObject

	self class = anObject class ifFalse: [^false].
	({Character. Number} anySatisfy: [:exceptionalClass| self isKindOf: exceptionalClass]) ifTrue: [^self = anObject].
	1 to: self class instSize do: [:index|
		((self instVarAt: index) unify: (anObject instVarAt: index)) ifFalse: [^false]].
	^true! !

!Object methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:48'!
unifyWithQuery: anUQuery 

	^anUQuery unifyWithNonQuery: self  ! !

Object subclass: #ObjectForTestingUnification1
	instanceVariableNames: 'proj cont'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification-Test'!

!ObjectForTestingUnification1 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
cont
	^ cont! !

!ObjectForTestingUnification1 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
cont: anObject
	cont := anObject! !

!ObjectForTestingUnification1 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
proj
	^ proj! !

!ObjectForTestingUnification1 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
proj: anObject
	proj := anObject! !

Object subclass: #ObjectForTestingUnification2
	instanceVariableNames: 'proj cont'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification-Test'!

!ObjectForTestingUnification2 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
cont
	^ cont! !

!ObjectForTestingUnification2 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
cont: anObject
	cont := anObject! !

!ObjectForTestingUnification2 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
proj
	^ proj! !

!ObjectForTestingUnification2 methodsFor: 'accessing' stamp: 'hjo 8/8/2012 19:29'!
proj: anObject
	proj := anObject! !

Object subclass: #UQuery
	instanceVariableNames: 'matchResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification'!

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:29'!
match: aSmallInteger 
	self shouldBeImplemented.! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:30'!
matchResult

	^ matchResult! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:48'!
unify: anObject

	^anObject unifyWithQuery: self! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:45'!
unifyWithNonQuery: anObject 

	matchResult := anObject.
	^true! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:50'!
unifyWithQuery: anObject 

	^self error: 'matching query to query cannot be determined.'.! !

!SequenceableCollection methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:36'!
unify: aSequenceableCollection

	self size = aSequenceableCollection size ifFalse: [^false].
	1 to: self size do: [:index|  | unificationResult |
		unificationResult := (self at: index) unify: (aSequenceableCollection at: index).
		unificationResult ifFalse: [^false] ].
	^true	! !

TestCase subclass: #UnificatoinTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification-Test'!

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:37'!
testArray1

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ({q1. q2} unify: 'hi').
	self assert: $h equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:56'!
testArray1Bidirectional

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ({q1. $i} unify: {$h. q2}).
	self assert: $h equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:42'!
testArray1Reversed

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ('hi' unify: {q1. q2}).
	self assert: $h equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 19:31'!
testClassCheck

	| obj1 obj2 |
	obj1 := ObjectForTestingUnification1 new.
	obj2 := ObjectForTestingUnification2 new.
	
	obj1 proj: 1.
	obj1 cont: 2.
	
	obj2 proj: 1.
	obj2 cont: 2.
	
	self deny: (obj1 unify: obj2).! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:54'!
testDeeperArray

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	self assert: ({{q1. $i}. {$t. $h. $e. q2. $e}} unify: {'hi'. 'there'}).
	self assert: $h equals: q1 matchResult.
	self assert: $r equals: q2 matchResult.! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 18:00'!
testDeeperArrayBidirectional

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ({{$h. q2}. {$t. $h. $e. $r. $e}} unify: {{$h. $i}. {q1. $h. $e. $r. $e}}).
	self assert: $t equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:43'!
testFailByValue

	self deny: (1 unify: 2).! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 21:30'!
testInstanceVariables

	| q1 q2 obj1 obj2 |
	q1 := UQuery new.
	q2 := UQuery new.

	obj1 := ObjectForTestingUnification1 new.
	obj2 := ObjectForTestingUnification1 new.
	
	obj1 proj: q1.
	obj1 cont: 4.
	
	obj2 proj: 3.
	obj2 cont: q2.
	
	self assert: (obj1 unify: obj2).
	self assert: 3 equals: q1 matchResult.
	self assert: 4 equals: q2 matchResult.! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:29'!
testInteger

	| q |
	q := UQuery new.
	q unify: 1.
	self assert: 1 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:30'!
testInteger2

	| q |
	q := UQuery new.
	q unify: 2.
	self assert: 2 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:41'!
testInteger2Reversed

	| q |
	q := UQuery new.
	2 unify: q.
	self assert: 2 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:39'!
testIntegerReversed

	| q |
	q := UQuery new.
	1 unify: q.
	self assert: 1 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:51'!
testQueryToQuery

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	self should: [q1 unify: q2] raise: Error.
	! !
